! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
! In this example a dataset with a table is ! created.
! Two attributes are added to each of the dataset ! and table.
! The attribute names of the dataset are displayed using
! access-by-number, and the table attribute names are displayed
! using access-by-name.
program example_attribute

  use dal
  implicit none
   
  type(DataSetT) set
  type(TableT) tab
  type(ArrayT) arr
   
  set = dataSet("test.dat",CREATE)
  call setAttribute(set,"sbool1",.false.,"dataset bool comment")
  call setAttribute(set,"sbool2",.true.,"dataset bool comment")
   
  tab = addTable(set,"table",10);
  call setAttribute(tab,"sbool1",.false.,"table bool comment")
  call setAttribute(tab,"sbool2",.true.,"table bool comment")

  write(*,*) name( attribute( set, 0 ))
  write(*,*) name( attribute( set, 1 ))
  write(*,*) name( attribute( tab, "sbool1" ))
  write(*,*) name( attribute( tab, "sbool2" ))

  call release(set)
   
end program example_attribute
