! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
! This example demonstrates the dimensions inteferface.

subroutine fillWithData( dataSetName )

  use dal

  implicit none

  character(len=*), intent(in) :: dataSetName
  type(DataSetT) set
  type(TableT) tab
  type(ColumnT) col
  integer(kind=INT32), dimension(:,:,:,:,:), pointer :: c
  integer, dimension(:), pointer :: s
  integer :: i,j,k,l,m,n

  ! Reopen dataset and fill with data.
  set = dataSet( dataSetName, MODIFY )
  tab = table( set, "table" )
  col = column( tab, "column", MODIFY )
  s => dimensions( col )
  c => int32Array4Data( col )

  n = 0
  do m=0,numberOfRows(tab) - 1
    do l=0, s(3) - 1
      do k=0, s(2) - 1
        do j=0, s(1) - 1
          do i=0, s(0) - 1
            c(i,j,k,l,m) = n
            n = n + 1
          end do
        end do
      end do
    end do
  end do

  call release(col)
  call release(set)

end subroutine fillWithData

program example_dimensions

  use dal

  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(ColumnT) col
  integer, dimension(4), parameter :: s = (/ 3,4,5,6 /)

  ! create a set
  set = dataSet("test.dat",CREATE)
  tab = addTable(set, "table", 100, "table comment" )
  col = addColumn( tab, "column", INTEGER32, "km", s, "column comment" )
  call release( set )

  call fillWithData( "test.dat" )

end program example_dimensions
