! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
! This example shows how to use the keepDataSet
! subroutine
program example_keepdiscarddataset

  use dal
  
  implicit none

  type(DataSetT) set

  set = dataSet("test.dat",CREATE)
  call release(set)		  ! The dataset will be released from memory

  call keepDataSet("test.dat")	  ! Tell the dataset server not to discard
  				  ! the dataset with name "test.dat"

  set = dataSet("test.dat",READ)
  call release(set)		  ! The dataset will not be released from memory

  set = dataSet("test.dat",READ)  ! The dataset is already in memory, so this
  				  ! operation has virtually no overhead.

  call release(set)		  ! The dataset will not be released from memory
  call discardDataSet("test.dat") ! Tell the dataset server to discard and
  				  ! release the dataset with name "test.dat"

end program example_keepdiscarddataset
