! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
! This example shows how the seek functions
! are used.
! This subroutine will dispaly the seek values of the given table and column.
subroutine whatisseek(tab)
  use dal

  type(TableT), intent(in) :: tab

  type(ColumnT) :: col

  write(*,*) from( tab ), count( tab )

  col = column(tab,"x",MODIFY)
  write(*,*) from( col ), count( col )

end subroutine whatisseek

program example_seek

  use dal

  implicit none

  type(DataSetT) :: set
  type(TableT) :: tab
  type(ColumnT) :: col

  interface
    subroutine whatisseek( subtab )
      use dal
      implicit none
      type(TableT), intent(in) :: subtab
    end subroutine whatisseek
  end interface

  set = dataSet("test.dat",CREATE)
  tab = addTable(set,"events",10)
  col = addColumn(tab,"x",real32,"mm")

  call forEachSubTable(tab,whatisseek)

  call release(set)

end program example_seek
