/* ESA (C) 2000-2018 
*
* This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
*
*    SAS is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    SAS is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with SAS.  If not, see <http:*www.gnu.org/licenses/>.
*/
#include <dal.h>
#include <stdio.h>
#include <math.h>

int main()
{
  DataSet *set;
  Table *tab;
  SubTable *st;
  ColumnData *xData, *yData, *rData;
  int16 *x, *y;
  real64 *r;
  unsigned i;

  set = dataSet("test.dat",MODIFY);
  tab = table(set,"events",MODIFY);
  st = subTable(tab);
  xData = subTableAddColumn(st,"x",READ);
  yData = subTableAddColumn(st,"y",READ);
  rData = subTableAddColumn(st,"r",CREATE);

  subTableSeek(st,10,20);
  x = int16Data(xData);
  y = int16Data(yData);
  r = real64Data(rData);
  for (i = 0; i < 10; ++i) {
    printf("%hd %hd\n", x[i], y[i]);
    r[i] = sqrt( sqr(x[i]) + sqr(y[i]) );
  }

  subTableRelease(st);
  dataSetRelease(set);

  return 0;
}
