// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
using namespace std;
#include <Dal.h>
#include <iostream>
#include <cmath>

int main()
{
  DataSet* set = dataSetServer->open("test.dat",
	DataSet::Modify);
  Table* tab = set->table("events",Table::Modify);

  SubTable s(tab);
  ColumnData *xData = s.addColumn("x",Column::Read);
  ColumnData *yData = s.addColumn("y",Column::Read);
  ColumnData *rData = s.addColumn("r",Column::Create);
  s.seek(10,20);

  int16*  x = xData->int16Data();
  int16*  y = yData->int16Data();
  real64* r = rData->real64Data();
  for (unsigned i = 0; i < 10; ++i) {
    clog << x[i] << ' ' << y[i] << endl;
    r[i] = sqrt( sqr(x[i]) + sqr(y[i]) );
  }

  delete set;

  return 0;
}

