! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
module dal

  use daltypes

  integer, parameter :: READ = 10
  integer, parameter :: CREATE = 11
  integer, parameter :: MODIFY = 12

contains

  function int16Data(col)
    type(ColumnT), intent(in) :: col
    integer(kind=int16), dimension(:), pointer :: int16Data
  end function

  function real64Data(col)
    type(ColumnT), intent(in) :: col
    real(kind=double), dimension(:), pointer :: real64Data
  end function

  function dataSet(name,mode)
    character(len=*), intent(in) :: name
    integer, intent(in) :: mode
    type(DataSetT) dataSet
  end function

  function table(set,name,mode)
    type(DataSetT), intent(in) :: set
    character(len=*), intent(in) :: name
    integer, intent(in) :: mode
    type(TableT) table
  end function

  function column(tab,name,mode)
    type(TableT), intent(in) :: tab
    character(len=*), intent(in) :: name
    integer, intent(in) :: mode
    type(ColumnT) column
  end function

  function next(tab)
    type(TableT), intent(in) :: tab
    logical next
  end function

end module dal
