// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
using namespace std;
/*************************************************************** 
* 
* DalArray.cc & XMM Science Analysis System (SAS) 
* 
* Class representing DAL Array. 
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: DalArray.cc,v 1.2 2004/03/05 14:43:00 eojero Exp $
* 
*****************************************************************/ 


#include "Tracer.h"


#include "DalArray.h"


DalArray::DalArray(
		const string &			name,
		DataType			dataType,
		const longVec&			size,
		const string &			units,
		const string &			label,
		DalDataSet *			parent )
	:
		DalBlock( name, Block::ArrayT, label, parent ),
		DalDataComponent( dataType, size, units, this )
{
	PROC
	ENDPROC
}


ArrayData *
DalArray::data(
		const longVec &			/*from = zero*/,
		const longVec &			/*count = zero*/,
		AccessMode			accessMode/*=AsParent*/ ) const
{
	PROC
	ArrayData* newArrayData = makeArrayData( accessMode );
	_dataObjects.push_back( newArrayData );
	RETURN newArrayData;

}


