// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*************************************************************** 
* 
* DalBlock.h               & XMM Science Analysis System (SAS) 
* 
* Class representing a Block.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: DalBlock.h,v 1.2 2004/03/05 14:43:00 eojero Exp $
* 
*****************************************************************/ 
#ifndef __DAL_BLOCK_H
#define __DAL_BLOCK_H


#include "Dal.h"
#include "DalAttributable.h"
#include "DalDataSet.h"


class DalBlock : public virtual Block, public DalAttributable, public DalChild<DataSet>, public DalChild<DalDataSet>
{
	public :

		// Constructors
		DalBlock(
			const std::string &	name,
			Type		type,
			const std::string &	label,
			DalDataSet *	parent );

		virtual ~DalBlock(){}
		virtual DalBlock& operator=( const DalBlock& );

    		Type		type() const;
		unsigned int	blockNumber() const;
    		void		printOn( ostream& os ) const;
		void		rename( const std::string & newName );
		std::string		parseName( const std::string & compoundName ) const;
		std::string		qualifiedName() const;
		//virtual void	releaseAll() {}

	private :

		Type			_type;

};


#endif


