// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*************************************************************** 
* 
* DalChild.h               & XMM Science Analysis System (SAS) 
* 
* Class representing a Child object.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: DalChild.h,v 1.2 2004/03/05 14:43:01 eojero Exp $ 
* 
*****************************************************************/ 
#ifndef DAL_CHILD_H
#define DAL_CHILD_H


#include "Child.h"
#include "Tracer.h"


template<class T>
class DalChild : public virtual Child<T>
{
	public :
		DalChild( const T * parent ) : _parent( parent ) {}
		virtual ~DalChild(){}

		T * parent() { PROC RETURN const_cast<T *>(_parent); }
		const T * parent() const { PROC RETURN _parent; }
		void parent( const T * parent ) { PROC _parent = parent; ENDPROC }
		bool isOrphan() const { PROC RETURN _parent == 0; }

	private :
		const T * _parent;

};


#endif
