// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*************************************************************** 
* 
* Dal_Labelled.h              & XMM Science Analysis System (SAS) 
* 
* Class representing DAL Labelled.
* 
* (c) 1998 ESA - Written by Mark Thomas, CARA
* 
* $Id: DalLabelled.h,v 1.2 2004/03/05 14:43:01 eojero Exp $
* 
*****************************************************************/ 
#ifndef __DAL_LABELLED_H
#define __DAL_LABELLED_H


#include <Dal.h>

#include "Tracer.h"

class DalLabelled : public virtual Labelled
{
	public :
		DalLabelled( const std::string & name, const std::string & label ) :
				_name( name ), _label( label ) { PROC ENDPROC }
		virtual ~DalLabelled() {}
		const std::string & name() const { PROC RETURN _name; }
		virtual void rename( const std::string & newName ) { PROC _name = newName; ENDPROC }
		const std::string & label() const { PROC RETURN _label; }
		void relabel( const std::string & newLabel ) { PROC _label = newLabel; ENDPROC }

		virtual std::string parseName( const std::string & ) const = 0;

	private :
		std::string	_name;
		std::string	_label;
};


#endif


