// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//  Giuseppe Vacanti (cosine science & computing bv)
//  September 12, 2002
// 
//   $Id: DataSetRecord.h,v 1.2 2004/03/05 14:43:02 eojero Exp $
#ifndef DATASETRECORD_H
#define DATASETRECORD_H

class DataSet;
#include<string>
#include<Dal.h>

// A reference-counted pointer to datasets.

class DataSetRecord {

public:
    DataSetRecord(const std::string & name);

    ~DataSetRecord() {}

    void dataSet(DataSet * set);
    DataSet * dataSet() const;

    Dal::AccessMode mode() const;
//    void mode(Dal::AccessMode mode);

    DataSetServer::MemoryModel model() const;
    void model(DataSetServer::MemoryModel model);

    DataSetRecord & operator++(); // prefix
//    DataSetRecord operator++(int); // postfix

    DataSetRecord & operator--(); // prefix
//    DataSetRecord operator--(int); // postfix

    unsigned long count() const;
    
    bool keep() const;
    void keep(bool keep);

    bool active() const;

    const std::string & name() const;

private:

    DataSetRecord(const DataSetRecord &);
    DataSetRecord & operator=(const DataSetRecord &);

    std::string name_;
    bool keep_;
    DataSet * set_;
    unsigned long count_;
    DataSetServer::MemoryModel model_;

};

#endif
