// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*************************************************************** 
* 
* MemCellData.h            & XMM Science Analysis System (SAS) 
* 
* Class representing the Data in a Column Cell. 
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: MemCellData.h,v 1.2 2004/03/05 14:43:03 eojero Exp $ 
* 
*****************************************************************/ 
#ifndef MEM_CELL_DATA
#define MEM_CELL_DATA


#include <Dal.h>
#include "MemData.h"
#include "DataStorage.h"
#include "DalCellData.h"
#include "DalColumn.h"


class MemCellData : public DalCellData, public MemData<DalColumn>
{
	public :

		MemCellData(
			DataStorage *			data,
			const DalColumn *		parent,
			unsigned long			rowNumber,
			unsigned long			from,
			unsigned long			count,
			AccessMode			accessMode );

		virtual ~MemCellData();

		void size( unsigned long elements );
		unsigned long size() const;
		unsigned long row() const;
		unsigned long elements() const;
		void seek( unsigned long from, unsigned long count );

};


#endif


