// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*************************************************************** 
* 
* MemDataSet.h               & XMM Science Analysis System (SAS) 
* 
* Class representing a DAL Data Set.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: MemDataSet.h,v 1.2 2004/03/05 14:43:03 eojero Exp $ 
* 
*****************************************************************/ 
#ifndef MEM_DATA_SET_H
#define MEM_DATA_SET_H


#include "Dal.h"
#include "DalBlock.h"
#include "DalLabelled.h"
#include "DalDataSet.h"
#include "DataSetReaderWriter.h"


class MemDataSet : public DalDataSet
{
	public :

		// Constructors
		MemDataSet(
				const std::string &			setName,
				AccessMode			openMode,
				DalDataSetServer *              server,
				DataSetReaderWriter*		readerWriter );

		MemDataSet( const MemDataSet & );
		//DalDataSet& operator=( const DalDataSet & );
	
		DalTable * makeTable(
			const std::string &		name,
			const std::string &		label,
			unsigned long		rows,
			DalDataSet *		parent );

		DalArray * makeArray(
			const std::string &			name,
			DataType			dataType,
			const longVec&			size,
			const std::string &			units,
			const std::string &			label,
			DalDataSet *			parent );

		virtual ~MemDataSet();

		void		printOn( ostream & os ) const;

	private :

		void readmodify();
		void create();
		void temp();
};


#endif
