// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*************************************************************** 
* 
* MemDalReaderWriter.h      & XMM Science Analysis System (SAS) 
* 
* Class representing DAL File Reader/Writer.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: MemDalReaderWriter.h,v 1.2 2004/03/05 14:43:03 eojero Exp $
* 
*****************************************************************/ 

#ifndef MEM_DAL_READER_WRITER_H
#define MEM_DAL_READER_WRITER_H


#include "DalReaderWriter.h"
#include "MemDalDatabase.h"


class MemDalReaderWriter : public virtual DalReaderWriter, public virtual MemDalDatabase
{
	public :

		MemDalReaderWriter();
	virtual ~MemDalReaderWriter() {}

		void read( DataSet* dataSet );
		void write( DataSet* dataSet );
};


#endif


