// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
using namespace std;
#include <Dal.h>
#include<iostream>
#include<cassert>

static void
test()
{
  for( unsigned int i = 0; i < 3; ++i )
  {
  	DataSet * set;

  	if( !dataSetServer -> exists( "test.dat" ))
	{
 		set = dataSetServer->open("test.dat",DataSet::Create);
  		dataSetServer->close(set);
	} // if

  	assert( dataSetServer -> exists( "test.dat" ));
  	dataSetServer -> remove( "test.dat" );
  	assert( !dataSetServer -> exists( "test.dat" ));
  	set = dataSetServer->open("test.dat",DataSet::Create);
  	dataSetServer->close(set);
  	assert( dataSetServer -> exists( "test.dat" ));
  	dataSetServer -> remove( "test.dat" );
  	assert( !dataSetServer -> exists( "test.dat" ));

  	set = dataSetServer->open("test.dat",DataSet::Create);
  	assert( dataSetServer -> exists( "test.dat" ));
  	dataSetServer->close(set);
  	assert( dataSetServer -> exists( "test.dat" ));
  	dataSetServer -> remove( "test.dat" );
  	assert( !dataSetServer -> exists( "test.dat" ));

  	set = dataSetServer->open("test.dat",DataSet::Create);
  	assert( dataSetServer -> exists( "test.dat" ));
  	dataSetServer -> remove( "test.dat" );
  	assert( !dataSetServer -> exists( "test.dat" ));

  	set = dataSetServer->open("test.dat",DataSet::Create);
  	assert( dataSetServer -> exists( "test.dat" ));
  	set = dataSetServer->open("test.dat",DataSet::Create);
  	assert( dataSetServer -> exists( "test.dat" ));
  	dataSetServer->close(set);
  	assert( dataSetServer -> exists( "test.dat" ));
  	dataSetServer->close(set);
  	assert( dataSetServer -> exists( "test.dat" ));
  	dataSetServer -> remove( "test.dat" );
  	assert( !dataSetServer -> exists( "test.dat" ));

  	set = dataSetServer->open("test.dat",DataSet::Create);
  	assert( dataSetServer -> exists( "test.dat" ));
  	set = dataSetServer->open("test.dat",DataSet::Create);
  	assert( dataSetServer -> exists( "test.dat" ));
  	dataSetServer -> remove( "test.dat" );
  	assert( !dataSetServer -> exists( "test.dat" ));

  } // if
}


int main()
{
  DataSet * set = dataSetServer->open("test.dat",DataSet::Create);
  dataSetServer->close(set);
  test();
  dataSetServer -> keep( "test.dat" );
  test();
  dataSetServer -> discard( "test.dat" );
  test();
  dataSetServer -> keep( "test.dat" );
  test();
  dataSetServer -> discard( "test.dat" );
  test();

  return 0;
}
