// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
using namespace std;
#include <Dal.h>
#include<iostream>

int main() {
  string name("test.ds");
  dataSetServer->keep(name);
  DataSet * set = dataSetServer->open(name, Dal::Create);
  set->addTable("table", 10);
  dataSetServer->close(set);

  cout << dataSetServer->exists(name) << endl;
  set = dataSetServer->open(name, Dal::Read);
  Table * table = set->table(0);
  cout << table->name() << endl;
  dataSetServer->close(set);
  dataSetServer->discard(name); // or it never goes to disk
}
