! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.


program test

  use dal
  
  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(ColumnT) col
  integer nRows
  nRows = 10

  ! **************
  ! Scalar Boolean
  ! **************
  set = dataSet("test.dat",CREATE)
  tab = addTable(set,"table",nRows)
  col = addColumn(tab,"col1",BOOLEAN)
  if( numberOfColumns( tab ) /= 1 ) then
      call error("testFailed","1 column expected" )
  end if
  call release(set)

  set = dataSet("test.dat",READ)
  tab = table(set,"table")
  if( numberOfColumns( tab ) /= 1 ) then
      call error("testFailed","1 column expected" )
  end if

  call release(set)

  set = dataSet("test.dat",MODIFY)
  tab = table(set,"table")
  if( numberOfColumns( tab ) /= 1 ) then
      call error("testFailed","1 column expected" )
  end if
  call deleteColumn( tab, "col1" )
  write(*,*) numberOfColumns( tab )
  if( numberOfColumns( tab ) /= 0 ) then
      call error("testFailed","0 columns expected" )
  end if
  call release(set)

  set = dataSet("test.dat",READ)
  tab = table(set,"table")
  write(*,*) numberOfColumns( tab )
  if( numberOfColumns( tab ) /= 0 ) then
      call error("testFailed","0 columns expected" )
  end if
  call release(set)

  set = dataSet("test.dat",MODIFY)
  tab = table(set,"table")
  col = addColumn(tab,"col1",BOOLEAN)
  col = addColumn(tab,"col2",BOOLEAN)
  col = addColumn(tab,"col3",BOOLEAN)
  col = addColumn(tab,"col4",BOOLEAN)
  col = addColumn(tab,"col5",BOOLEAN)
  col = addColumn(tab,"col6",BOOLEAN)
  col = addColumn(tab,"col7",BOOLEAN)
  col = addColumn(tab,"col8",BOOLEAN)
  col = addColumn(tab,"col9",BOOLEAN)
  col = addColumn(tab,"col10",BOOLEAN)
  if( numberOfColumns( tab ) /= 10 ) then
      call error("testFailed","10 column expected" )
  end if
  call deleteColumn(tab,"col1")
  call deleteColumn(tab,"col10")
  call deleteColumn(tab,"col5")
  if( numberOfColumns( tab ) /= 7 ) then
      call error("testFailed","7 column expected" )
  end if
  call release(set)

  set = dataSet("test.dat",READ)
  tab = table(set,"table")
  if( numberOfColumns( tab ) /= 7 ) then
      call error("testFailed","7 column expected" )
  end if
  call release(set)

  set = dataSet("test.dat",MODIFY)
  tab = table(set,"table")
  write(*,*) numberOfColumns( tab )
  if( numberOfColumns( tab ) /= 7 ) then
      call error("testFailed","7 column expected" )
  end if
  call deleteColumn(tab,0)
  write(*,*) numberOfColumns( tab )
  call deleteColumn(tab,0)
  write(*,*) numberOfColumns( tab )
  call deleteColumn(tab,0)
  write(*,*) numberOfColumns( tab )
  call deleteColumn(tab,0)
  write(*,*) numberOfColumns( tab )
  call deleteColumn(tab,0)
  write(*,*) numberOfColumns( tab )
  call deleteColumn(tab,0)
  write(*,*) numberOfColumns( tab )
  call deleteColumn(tab,0)
  write(*,*) numberOfColumns( tab )
  if( numberOfColumns( tab ) /= 0 ) then
      call error("testFailed","0 column expected" )
  end if
  call release(set)

end program test

