! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
program test

  use dal
  use errorhandling
  
  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(ColumnT) col
  !logical, dimension(:), pointer :: b
  integer(kind=int8), dimension(:), pointer :: i8
  integer(kind=int16), dimension(:), pointer :: i16
  integer(kind=int32), dimension(:), pointer :: i32
  real(kind=single), dimension(:), pointer :: r32
  real(kind=double), dimension(:), pointer :: r64
  integer i
  integer, parameter :: nRows = 10

  set = dataSet("test.dat",READ)
  tab = table(set,"someTable")
  if (numberOfRows(tab) /= nRows) &
    call error("testFailed","wrong nr of rows")

  !col = column(tab,"bool",READ)

  col = column(tab,"int8",READ)
  i8 => int8Data(col)
  write(*,*) shape(i8)
  if (any(shape(i8) /= (/ 10 /))) call error("testFailed","shape i8")
  do i=0,numberOfRows(tab)-1
    if (i8(i) /= i) call error("testFailed","value i8")
  end do
  call release(col)
    
  col = column(tab,"int16",READ)
  i16 => int16Data(col)
  if (any(shape(i16) /= (/ 10 /))) call error("testFailed","shape i16")
  do i=0,numberOfRows(tab)-1
    if (i16(i) /= 2*i) call error("testFailed","value i16")
  end do
  call release(col)

  col = column(tab,"int32",READ)
  i32 => int32Data(col)
  if (any(shape(i32) /= (/ nRows /))) call error("testFailed","shape i32")
  do i=0,numberOfRows(tab)-1
    if (i32(i) /= 3*i) call error("testFailed","value i32")
  end do
  call release(col)

  col = column(tab,"real32",READ)
  r32 => real32Data(col)
  if (any(shape(r32) /= (/ nRows /))) call error("testFailed","shape r32")
  do i=0,numberOfRows(tab)-1
    if (r32(i) /= 0.5*i) call error("testFailed","value r32")
  end do
  call release(col)

  col = column(tab,"real64",READ)
  r64 => real64Data(col)
  if (any(shape(r64) /= (/ nRows /))) call error("testFailed","shape r64")
  do i=0,numberOfRows(tab)-1
    if (r64(i) /= 0.25*i) call error("testFailed","value r64")
  end do
  call release(col)

  !col = column(tab,"string",READ)

  call release(set)

end program test
