! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.

program test

  use dal
  use errorHandling
  
  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(ArrayT) arr

  if( setExists( "abcdefghijklmnopqrstuvwxyz.dat123" ) ) then
    write(errstr,*) "setExists found a non-existant file"
    call error("internalError")
  endif

  set = dataSet("test.dat",CREATE)
  call release( set )
  if( .not.setExists( "test.dat" ) ) then
    write(errstr,*) "setExists did not find an existant file"
    call error("internalError")
  endif

end program test
