// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
#include <SmartDal>
#include <iostream>

// Very simple test.

int main() {
    using namespace SmartDal;
    {
    DataSetH s= SmartDal::open_set("smart.ds", Create);
    TableH t = s->addTable("Table", 10);
    
    AttributeH a = t->addAttribute("HelloB");
     *a = false;

     AttributeH b = t->addAttribute("HelloF");
     *b = 42.;


     ColumnH c = t->addColumn("Column", Dal::Int32);
     ColumnDataH cd = c->data();
     
//     // This does not release the columnData object
//     int32 * v = c->data()->int32Data();

     int32 * v = cd->int32Data();
     for(unsigned k = 0; k < t->rows(); ++k)
 	v[k] = k;

     longVec dim;
     dim.push_back(10);

     ColumnH cs = t->addColumn("ColumnString", Dal::DString, "", "", dim);
     ColumnDataH cds = cs->data();
     for(unsigned k = 0; k < t->rows(); ++k)
       set_string_row(cs, k, "0123456789");
     for(unsigned k = 0; k < t->rows(); ++k)
       std::cout << get_string_row(cs, k) << std::endl;

    }
    std::cout << "Second pass" << std::endl;
    DataSetH s= SmartDal::open_set("smart.ds", Read);
    TableH t = s->table("Table");
    ColumnH cs = t->column("ColumnString");
    for(unsigned k = 0; k < cs->rows(); ++k)
      std::cout << get_string_row(cs, k) << std::endl;
}


