// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
using namespace std;
//
// XMM Science Analysis System
//
// Giuseppe Vacanti (cosine science & computing) 
// October 2001
//

#include<iostream>
#include<Dal.h>
#include<Tracer.h>
/* AI gcc4 porting
 *  strncpy was not declared in this scope
 * include <string.h>
 */
#include <string.h>

int main() {

  tracer.trace(true);
/* AI gcc4 porting
 *  deprecated conversion from string constant to char*=> cast to(char*)
 */
  char * t1 = (char*) "12345";
  char * t2 = (char*) "123";
  char * t3 = (char*) "12\0";

  dataSetServer->client("dal_test");
  std::string name("spr1656.ds");
  
  DataSet * set = dataSetServer->open(name, Dal::Create);
  Table * tab = set->addTable("table", 10);
  longVec size(1,5);
  Column * col = tab->addColumn("column", Dal::DString, "", "", size);
  ColumnData * cd = col->data();
  char * cv = cd->stringData();
  strncpy(cv, t1, 5);
  strncpy(cv + 5, t2, 5);
  strncpy(cv + 10, t3, 5);
  delete cd;
  dataSetServer->close(set);
}
