// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
using namespace std;
//
// XMM Science Analysis System
//
// Giuseppe Vacanti (cosine science & computing) 
// October 2001
//
#include<Dal.h>
#include<string>
#include<ExceptionErrorHandler.h>
#include<errstr.h>
#include<vector>
#include<cassert>
/* AI gcc4 porting
 * 'exit' was not declared in this scope => include cstdlib.h
 */
#include <cstdlib>

int main() {

  ExceptionErrorHandler thrower;
  errHandler.handler(&thrower);

  std::vector<std::string> tables;
  tables.push_back("set.ds");
  tables.push_back("set1.ds");


  size_t k = 0;
  DataSet * set =  dataSetServer->open(tables[k], Dal::Create);
  
  try {
    set->table(tables[k]);
  }
  // I rely on a specific string to be in the error message
  catch(SasException::Exception e){
    std::cout << "Failed with " << e.message << std::endl;
    assert(e.message.find("Most likely you failed to specify append a ':' to") !=
	   std::string::npos);
    std::cout << "Failed as expected with " << e.message << std::endl;    
    
    dataSetServer->close(set);
    exit(0);
  }
  exit(1);
}
