// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
using namespace std;
//
// XMM Science Analysis System
//
// Giuseppe Vacanti (cosine science & computing) 
// October 2001
//
// $Id: spr2124.cc,v 1.2 2004/03/05 14:43:04 eojero Exp $
//
#include<Dal.h>

int main() {

  dataSetServer->client("dal_test");
  
  std::string set1("spr2124.ds");
  const size_t nrows = 100;
  DataSet *s1 = dataSetServer->open(set1, Dal::Create);
  Table *t = s1->addTable("TABLE", nrows);  
  Column * c = t->addColumn("int32",Dal::Int32);
  dataSetServer->close(s1);

  s1 = dataSetServer->open(set1, Dal::Modify);
  t = s1->table("TABLE");
  c = t->column("int32", Dal::Read);
  c->release();
  //  t->release();

  t->insertRows(10,10);
  dataSetServer->close(s1);
}  

  
