! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
program spr2159f90
  ! Giuseppe Vacanti, October 2001
  ! It relies on being run after the corresponding c++ version, as it
  ! expects the input data file to be present.

  use Dal
  type(DataSetT) :: inSet, outSet
  type(BlockT) :: blk
  integer :: i

  

  inSet = dataSet("spr2159_origin.ds", READ, HIGH_MEMORY)
  outSet = dataSet("spr2159_destination_f90.ds", CREATE, HIGH_MEMORY)

  do i=0,numberOfBlocks(inSet)-1
     blk = block(inSet,i, READ)
     call copyBlock(outSet, blk)
  end do

  call release(inSet)
  call release(outSet)

end program spr2159f90
