// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//
// XMM Science Analysis System
//
// Giuseppe Vacanti (cosine science & computing) 
// January 2002
//
// $Id: spr2253.cc,v 1.2 2004/03/05 14:43:04 eojero Exp $
#include<Dal.h>
#include<cassert>
#include <iostream>
int main() {

  dataSetServer->client("spr2253");
  std::string name("spr2253.ds");

  DataSet * set = dataSetServer->open(name, Dal::Create);
  dataSetServer->close(set); // History record (Created by)

  set = dataSetServer->open(name, Dal::Modify);
  
  DataSet * setr = dataSetServer->open(name, Dal::Read);

  dataSetServer->close(set); // History record (Modified by)  
  dataSetServer->close(setr); // No history record expected, but created (bug)

  setr = dataSetServer->open(name, Dal::Read);
  for(unsigned k = 0; k < setr->historys(); ++k)
    std::cout << setr->history(k) << std::endl;

  assert(setr->historys() == 2);

  dataSetServer->close(setr);
}

  
