// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//  Giuseppe Vacanti (cosine science & computing bv)
//  January 27, 2003
// 
//   $Id: spr2294.cc,v 1.2 2004/03/05 14:43:04 eojero Exp $
#include<Dal.h>
#include<NAN.h>
#include<cassert>

int main() {
 std::string f("spr2294.ds");
 DataSet * set = dataSetServer->open(f, Dal::Create);
 *set->addAttribute("rouge") = 1234.5678;
 double rouge;
 NaN.set(rouge);
 *set->addAttribute("rouge") = rouge;
 // Now I expect the attribute to be blank
 assert(set->attribute("rouge")->asString() == "");
 assert(set->attribute("rouge")->label() == "AttributeNaN. Last value 1234.5678");
 dataSetServer->close(set);
}
