// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//  Giuseppe Vacanti (cosine science & computing bv)
//  September  9, 2002
// 
//   $Id: spr2311.cc,v 1.3 2009/06/22 15:58:03 rsaxton Exp $
#include <Dal.h>
#include<string>
#include<ExceptionErrorHandler.h>
#include<errstr.h>
#include<iostream>
#include<cassert>
/* AI gcc4 porting
 * exit was not declared in this scope => #include<cstdlib>
 */
#include<cstdlib>

// The name PRIMARY is reserved to arrays

int main() {

    ExceptionErrorHandler thrower;
    errHandler.handler(&thrower);
    
    std::string name("spr2311.ds");
    DataSet * set = 0;
    set = dataSetServer->open(name, Dal::Create);
    try {
	Table * tab = set->addTable("PRIMARY", 0);
	tab->label(); // must use the variable
    }
    catch (SasException::Exception e){
        std::cerr << "Failed with message:" << e.message << std::endl;
        assert(e.message.find("You cannot add a table with the name PRIMARY because this block name is reserved for the first nameless array in a dataset.") != std::string::npos);
        exit(0);
    }

    dataSetServer->close(set);
    std::cerr << "Did not fail as expected." << std::endl;
    exit(1);

    dataSetServer->close(set);

}
